package com.tacosteemers.examples.eventtracking.springbootmdc;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.slf4j.MDC;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import java.io.IOException;
import java.util.UUID;

@Component
@Order(1)
public class RequestTaggingFilter implements Filter {

    private static final Logger LOGGER = LoggerFactory.getLogger(RequestTaggingFilter.class);

    @Override
    public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException {

        // We use a "universally unique identifier" to tag the request.
        // This is a 16 byte long hexadecimal String generated by a pseudo-random number generator.
        // https://www.ietf.org/rfc/rfc4122.txt
        //
        // The UUID class is a part of the Java language; it does not need a dependency.
        MDC.put("reqId", UUID.randomUUID().toString());


        LOGGER.info("Start of request");

        // Move the request further down in to the application; it will end up at the requested endpoint.
        chain.doFilter(request, response);

        // The final log statement will be made after the endpoint has processed the request.
        LOGGER.info("End of request");
    }
}
